/*
 *                      SIEVE.C
 *                Sieve of Eratosthenes.
 */

#define ITERATIONS 1000
#define ARRAYSIZE  1000
#define SIZE       999

#include <stdio.h>
#include <time.h>

typedef enum
{
  FALSE = 0,
  TRUE = !FALSE
} bool;

static bool Flags [ARRAYSIZE];

void main (void)
{
  unsigned short iters, count, prime, i, j, k;
  float duration;
  time_t start_time, stop_time;

  iters = ITERATIONS;
  start_time = clock();
  for (k = 1; k <= ITERATIONS; k++)
  {
    count = 0;
    for (i = 0; i <=SIZE; i++)
      Flags[i] = TRUE;
    for (i = 0; i <= SIZE; i++)
    {
      if (Flags[i])
      {
        prime = 2 * i + 3;
        j     = i + prime;
        while (j <= SIZE)
        {
          Flags[j] = FALSE;
          j += prime;
        }
        count++;
      }
    }
  }


  stop_time = clock ();
  duration = (stop_time - start_time)/((float) CLK_TCK);  
  printf ("\nBorland C Sieve of Eratosthenes\n");
  printf ("Number of primes was %u", count);
  printf ("\n%u iterations took %fl seconds\n", iters, duration);
}
